'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash.set');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.get');

var _lodash4 = _interopRequireDefault(_lodash3);

var _lodash5 = require('lodash.has');

var _lodash6 = _interopRequireDefault(_lodash5);

var _lodash7 = require('lodash.isstring');

var _lodash8 = _interopRequireDefault(_lodash7);

var _lodash9 = require('lodash.reduce');

var _lodash10 = _interopRequireDefault(_lodash9);

var _lodash11 = require('lodash.defaultsdeep');

var _lodash12 = _interopRequireDefault(_lodash11);

var _lodash13 = require('lodash.clonedeep');

var _lodash14 = _interopRequireDefault(_lodash13);

var _lodash15 = require('lodash.foreach');

var _lodash16 = _interopRequireDefault(_lodash15);

var _lodash17 = require('lodash.map');

var _lodash18 = _interopRequireDefault(_lodash17);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _emptyFunc = require('./utils/emptyFunc');

var _emptyFunc2 = _interopRequireDefault(_emptyFunc);

var _arrayFrom = require('./utils/arrayFrom');

var _arrayFrom2 = _interopRequireDefault(_arrayFrom);

var _pickDeep = require('./utils/pickDeep');

var _pickDeep2 = _interopRequireDefault(_pickDeep);

var _pickOutermost = require('./utils/pickOutermost');

var _pickOutermost2 = _interopRequireDefault(_pickOutermost);

var _mergeTouchedValues = require('./utils/mergeTouchedValues');

var _mergeTouchedValues2 = _interopRequireDefault(_mergeTouchedValues);

var _valuesWithDefaultsAndExemptions = require('./utils/valuesWithDefaultsAndExemptions');

var _valuesWithDefaultsAndExemptions2 = _interopRequireDefault(_valuesWithDefaultsAndExemptions);

var _Wildcard = require('./constants/Wildcard');

var _Wildcard2 = _interopRequireDefault(_Wildcard);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Joi = void 0;

var DEFAULT_STATE = {
  errors: {},
  values: {},
  touchedValues: {},

  validateAllValues: false
};

var ReactJoiValidation = function ReactJoiValidation(ValidatedComponent, _ref) {
  var joiSchema = _ref.joiSchema,
      joiOptions = _ref.joiOptions,
      validator = _ref.validator,
      only = _ref.only,
      _ref$pseudoValues = _ref.pseudoValues,
      pseudoValues = _ref$pseudoValues === undefined ? [] : _ref$pseudoValues;

  function usingSingularValidationScope() {
    return (0, _lodash8.default)(only);
  }

  function wrapObject(object) {
    if (usingSingularValidationScope()) {
      return _defineProperty({}, only, object);
    } else {
      return object;
    }
  }

  function unwrapObject(object) {
    if (usingSingularValidationScope()) {
      return object[only];
    } else {
      return object;
    }
  }

  function pickErrors(errors, touchedValues) {
    var listOfTouchedValues = (0, _pickOutermost2.default)(touchedValues);

    var valuesToPick = [].concat(_toConsumableArray(listOfTouchedValues), _toConsumableArray(pseudoValues));

    return (0, _lodash10.default)(valuesToPick, function (activeErrors, valuePath) {

      if (!valuePath.endsWith(_Wildcard2.default)) {
        (0, _lodash2.default)(activeErrors, valuePath, (0, _lodash4.default)(errors, valuePath));
      }

      return activeErrors;
    }, {});
  }

  var ValidatorComponent = function (_Component) {
    _inherits(ValidatorComponent, _Component);

    function ValidatorComponent(props, context) {
      _classCallCheck(this, ValidatorComponent);

      var _this = _possibleConstructorReturn(this, (ValidatorComponent.__proto__ || Object.getPrototypeOf(ValidatorComponent)).call(this, props, context));

      _this.changeHandler = _this.changeHandler.bind(_this);
      _this.changesHandler = _this.changesHandler.bind(_this);
      _this.changeValue = _this.changeValue.bind(_this);
      _this.changeValues = _this.changeValues.bind(_this);

      _this.validateHandler = _this.validateHandler.bind(_this);
      _this.validate = _this.validate.bind(_this);

      _this.validateAll = _this.validateAll.bind(_this);
      _this.validateAllHandler = _this.validateAllHandler.bind(_this);

      _this.clear = _this.clear.bind(_this);

      _this.state = _extends({}, DEFAULT_STATE);
      return _this;
    }

    _createClass(ValidatorComponent, [{
      key: 'render',
      value: function render() {
        var _state = this.state,
            touchedValues = _state.touchedValues,
            values = _state.values;


        return _react2.default.createElement(ValidatedComponent, _extends({}, this.props, this._valuesWithDefaults({ values: values, touchedValues: touchedValues }), {

          errors: this._getActiveErrors(),

          changeHandler: this.changeHandler,
          changesHandler: this.changesHandler,
          changeValue: this.changeValue,
          changeValues: this.changeValues,

          validateHandler: this.validateHandler,
          validate: this.validate,

          validateAllHandler: this.validateAllHandler,
          validateAll: this.validateAll,

          clearValidationState: this.clear
        }));
      }
    }, {
      key: '_getActiveErrors',
      value: function _getActiveErrors() {
        var _state2 = this.state,
            errors = _state2.errors,
            validateAllValues = _state2.validateAllValues,
            touchedValues = _state2.touchedValues;


        if (validateAllValues) {
          return errors;
        } else {
          return pickErrors(errors, touchedValues);
        }
      }
    }, {
      key: '_valuesWithDefaults',
      value: function _valuesWithDefaults(_ref3) {
        var values = _ref3.values,
            touchedValues = _ref3.touchedValues;


        if (only) {
          var validateableFields = (0, _arrayFrom2.default)(only);

          var propValues = (0, _pickDeep2.default)(this.props, validateableFields);

          var defaultValues = (0, _pickDeep2.default)(ValidatedComponent.defaultProps, validateableFields);

          var propsWithDefaults = (0, _lodash12.default)({}, propValues, defaultValues);

          return (0, _valuesWithDefaultsAndExemptions2.default)({
            defaultValue: propsWithDefaults,
            overrides: wrapObject(values),
            deepMergeExemptions: wrapObject(touchedValues)
          });
        } else {
          var _propsWithDefaults = (0, _lodash12.default)({}, this.props, ValidatedComponent.defaultProps);

          return (0, _valuesWithDefaultsAndExemptions2.default)({
            defaultValue: _propsWithDefaults,
            overrides: wrapObject(values),
            deepMergeExemptions: wrapObject(touchedValues)
          });
        }
      }
    }, {
      key: 'clear',
      value: function clear() {
        this.setState(_extends({}, DEFAULT_STATE));
      }
    }, {
      key: 'changeHandler',
      value: function changeHandler(valuePath) {
        var _this2 = this;

        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        return function (event, value) {
          var valueToUse = (0, _lodash6.default)(options, 'value') ? options.value : value;
          _this2.changeValue(valuePath, valueToUse, options);
        };
      }
    }, {
      key: 'changesHandler',
      value: function changesHandler(changes, options) {
        var _this3 = this;

        return function () {
          _this3.changeValues(changes, options);
        };
      }
    }, {
      key: 'changeValue',
      value: function changeValue(valuePath, value) {
        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

        (0, _invariant2.default)(!Array.isArray(valuePath), 'Value path passed to changeValue was an array. If you want to change multiple values at once, use `changeValues` (pluralized) instead.');

        this.changeValues([[valuePath, value]], options);
      }
    }, {
      key: 'changeValues',
      value: function changeValues(changes) {
        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        (0, _invariant2.default)(Array.isArray(changes), 'Changes must be an array of path-value pairs');

        if (options.validate) {

          var valuePaths = function () {
            if (options.validate === true) {
              return (0, _lodash18.default)(changes, function (_ref4) {
                var _ref5 = _slicedToArray(_ref4, 1),
                    valuePath = _ref5[0];

                return valuePath;
              });
            } else {
              return options.validate;
            }
          }();

          var nextState = this._newState({ valuePaths: valuePaths, changes: changes });

          this._validate(nextState);
        } else {
          var _nextState = this._newState({ changes: changes });

          this.setState(_nextState);
        }
      }
    }, {
      key: '_newState',
      value: function _newState(_ref6) {
        var valuePaths = _ref6.valuePaths,
            changes = _ref6.changes;
        var _state3 = this.state,
            touchedValues = _state3.touchedValues,
            values = _state3.values;


        var newValues = function () {
          if (changes) {
            var _ret = function () {
              var previousValues = (0, _lodash14.default)(values);

              (0, _lodash16.default)(changes, function (_ref7) {
                var _ref8 = _slicedToArray(_ref7, 2),
                    path = _ref8[0],
                    value = _ref8[1];

                (0, _lodash2.default)(previousValues, path, value);
              });

              return {
                v: previousValues
              };
            }();

            if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
          } else {

            return _extends({}, values);
          }
        }();

        var newTouchedValues = function () {
          if (valuePaths) {
            var valuePathsList = (0, _arrayFrom2.default)(valuePaths);

            return (0, _mergeTouchedValues2.default)(valuePathsList, touchedValues);
          } else {
            return touchedValues;
          }
        }();

        return _extends({}, this.state, {
          values: newValues,
          touchedValues: newTouchedValues
        });
      }
    }, {
      key: 'validateAllHandler',
      value: function validateAllHandler() {
        var _this4 = this;

        var validateAllValues = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
        var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _emptyFunc2.default;


        return function () {
          _this4.validateAll(validateAllValues, callback);
        };
      }
    }, {
      key: 'validateAll',
      value: function validateAll() {
        var validateAllValues = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
        var callback = arguments[1];

        this._validate(_extends({}, this.state, { validateAllValues: validateAllValues }), callback);
      }
    }, {
      key: 'validateHandler',
      value: function validateHandler(valuePaths) {
        var _this5 = this;

        var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : (0, _emptyFunc2.default)();


        return function () {
          _this5.validate(valuePaths, callback);
        };
      }
    }, {
      key: 'validate',
      value: function validate(valuePaths) {
        var afterValidationCallback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _emptyFunc2.default;

        this._validate(this._newState({ valuePaths: valuePaths }), afterValidationCallback);
      }
    }, {
      key: '_validate',
      value: function _validate(nextState, afterValidationCallback) {
        var _this6 = this;

        var afterValidationHandler = this._afterValidationHandler(nextState, afterValidationCallback);

        var valuesWithDefaults = unwrapObject(this._valuesWithDefaults(nextState));

        if (joiSchema) {
          Joi.validate(valuesWithDefaults, joiSchema, _extends({ abortEarly: false }, joiOptions), function (joiError) {
            var joiErrorList = joiError && joiError.details || [];

            var errors = (0, _lodash10.default)(joiErrorList, function (joiErrors, _ref9) {
              var message = _ref9.message,
                  path = _ref9.path;

              var messageWithFieldNameRemoved = message.replace(/^\".+\" /, '');

              (0, _lodash2.default)(joiErrors, path, messageWithFieldNameRemoved);

              return joiErrors;
            }, {});

            _this6._callValidatorIfDefined(_extends({}, nextState, {
              errors: errors,
              valuesWithDefaults: valuesWithDefaults
            }), afterValidationHandler);
          });
        } else {
          this._callValidatorIfDefined(_extends({}, nextState, {
            errors: {},
            valuesWithDefaults: valuesWithDefaults
          }), afterValidationHandler);
        }
      }
    }, {
      key: '_callValidatorIfDefined',
      value: function _callValidatorIfDefined(_ref10, afterValidatorHasRun) {
        var values = _ref10.values,
            errors = _ref10.errors,
            touchedValues = _ref10.touchedValues,
            valuesWithDefaults = _ref10.valuesWithDefaults,
            validateAllValues = _ref10.validateAllValues;


        if (validator) {
          validator({
            valuePaths: (0, _pickOutermost2.default)(touchedValues),
            valuesWithDefaults: valuesWithDefaults, validateAllValues: validateAllValues, values: values, errors: errors
          }, afterValidatorHasRun);
        } else {
          afterValidatorHasRun({ values: values, errors: errors });
        }
      }
    }, {
      key: '_afterValidationHandler',
      value: function _afterValidationHandler(nextState, afterValidationComplete) {
        var _this7 = this;

        return function (_ref11) {
          var errors = _ref11.errors,
              values = _ref11.values;


          var newState = _extends({}, nextState, { errors: errors, values: values
          });

          _this7.setState(newState, afterValidationComplete);
        };
      }
    }]);

    return ValidatorComponent;
  }(_react.Component);

  ValidatorComponent.propTypes = {
    onSubmit: _react.PropTypes.func,
    errors: _react.PropTypes.object,
    onChange: _react.PropTypes.func
  };

  return ValidatorComponent;
};

ReactJoiValidation.setJoi = function (joiClass) {
  Joi = joiClass;
};

exports.default = ReactJoiValidation;